---
title: ビュー
page_id: "070.0"
---

## ビュー

Webアプリケーションにおけるビューの役割は、HTMLドキュメントを生成し、レスポンスとして返すことです。開発者は、コントローラから渡された変数を所定の部分に埋め込むためのHTMLドキュメントのテンプレート（ひな形）を作成します。

TreeFrog Framework のビューには、今のところ 2 つのテンプレートシステムを採用しています。ERB と Otama です。どちらもテンプレートを使って動的に値を出力したり、条件分岐やループ処理が行えます。

ERB は、Ruby にあるような、プログラムコードをテンプレートに埋め込むシステム（ライブラリ）のことです。仕組みが簡単で理解しやすいというメリットがある一方、Web デザインの確認や変更がしにくい面があります。

Otama は、テンプレートとプレゼンテーションロジックを完全に分離したテンプレートシステムです。Web デザインの確認や変更がしやすく、プログラマとデザイナが協業しやすいというメリットがありますが、仕組みは少し複雑で学習コストはかかるでしょう。

性能はどちらも変わりません。
これらのコードをビルドすると、テンプレートは C++ コードへ変換された後にコンパイルされ、１つの共有ライブラリ（ダイナミックリンクライブラリ）が作られます。なので、どちらも高速に動作します。あとはユーザが記述するコード次第といえるでしょう。

* [ERB テンプレートシステム の章へ >>](/ja/user-guide/view/erb.html){:target="_blank"}
* [Otama テンプレートシステム の章へ >>](/ja/user-guide/view/otama-template-system.html){:target="_blank"}